



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ARM非对齐操作异常解决过程</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ARM非对齐操作异常解决过程</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 00:19:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在测试MF固件时，发生一个非常诡异的异常，代码如下：</p>
<div>
<pre class="prettyprint linenums">    CLR_DBG_Commands::Monitor_EraseMemory* cmd = (CLR_DBG_Commands::Monitor_EraseMemory*)msg-&gt;m_payload;

    debug_printf("EraseMemory addr=0x%08x len=%d\r\n", cmd-&gt;m_address, cmd-&gt;m_length);</pre>
</div>
<p>指定第二行代码时，会跳到异常处理程序，发生了6号异常（用法异常Usage Fault）</p>
<p>我对ARM还是非常陌生，不知道怎么可能发生这个问题。<br />在今天之前，这行代码执行了无数次也未曾出错，最近也没有修改该函数或者相关函数的代码，昨天倒是大量修改了其它代码。</p>
<p>1，百度找资料<br />关键点是用法异常Usage Fault，以此为关键字搜索。有资料（<a href="http://www.docin.com/p-633872264.html" rel="external nofollow noreferrer">http://www.docin.com/p-633872264.html</a>）指出，用法异常包括：执行未定义指令、非对齐操作、除零。<br />前后两个显然不可能，中间这个非对齐操作倒是引起了我的注意。因为阅读MFPK代码的时候看到很多对齐操作的设计。</p>
<p>2，Keil调试<br />在Keil中调试这两行代码</p>
<div>
<pre class="prettyprint linenums">0x080071DA 6A74      LDR      r4,[r6,#0x24]<br />
  :         debug_printf("EraseMemory addr=0x%08x len=%d\r\n", cmd-&gt;m_address, cmd-&gt;m_length);<br />
  :<br />
0x080071DC A012      ADR      r0,{pc}+  ; @0x08007228<br />
0x080071DE E9D41200  LDRD     r1,r2,[r4,#]<br />
0x080071E2 F001FD93  BL.W     debug_printf (0x08008D0C)</pre>
</div>
<p>抛出异常的是0x080071DE这一行，代码是LDRD r1,r2,[r4,#0]，大意是把r4开始，偏移#0的数据加载到r1，下一个字加载到r2<br />从寄存其中看到，r4此时是0x200006D2，这是半字对齐而不是字对齐。<br />奇怪了，MDK为啥编译一个半字对齐的呢？<br />回到第一行代码的msg-&gt;m_payload，它是关键。因为它就是0x200006D2，如果r4没有字对齐，那么肯定跟这个msg-&gt;m_payload有关。<br />我们看看msg-&gt;m_payload是哪里分配的！</p>
<p>3，寻根<br />从代码中看到msg-&gt;m_payload来自msg-&gt;m_payload = pThis-&gt;m_receptionBuffer;<br />而m_receptionBuffer的声明</p>
<div>
<pre class="prettyprint linenums">    COM_HANDLE    m_port;<br />
    UINT8         m_receptionBuffer[  ];<br />
    UINT32        m_flags;<br />
    UINT32        m_lastPacketSequence;<br />
    WP_Controller m_controller;</pre>
</div>
<p>到这里，就明白了！<br />因为我昨天把typedef INT32 COM_HANDLE;改为了typedef INT16 COM_HANDLE;</p>
<p>非对齐操作相关资料<br />http://www.docin.com/p-218037008.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93vvn83.html">Selenium的PO模式（Page Object Model）&lbrack;python版&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zygox9.html">关于mySQL自连接的一些用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o44dpq.html">gcc boost版本冲突解决日记</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlpkvk9.html">自绘制HT For Web ComboBox下拉框组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oozgl8.html">IOS下自定义click事件使用alert引发的血案</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96w4vnq.html">input、button、文字的对齐水平对齐</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zmegn9.html">javascript的onbeforeunload函数在IOS上运行</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x7jnr9.html">lightoj 1024 （高精度乘单精度）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xnjez8.html">C&num;总结3</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljl3v09.html">iOS制作Static Library&lpar;静态库&rpar;，实现多工程的连编</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjn3wg8.html">uint8与double，二维矩阵显示灰度图</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jxexl8.html">Integer比较值的时候小心使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp437vq.html">基于Django的独立运行脚本开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/96perk38.html">《Linux下cp  XXX1 XXX2的功能》的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me37w2q.html">JavaScript中闭包的写法和作用详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mwrkn8.html">Voronoi图和Delaunay三角剖分</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyylnddq.html">linux中fork（）函数详解【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r53l0mq.html">maven名词解释</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwvyvj9.html">MHA 实现VIP切换用到脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1kjyg9.html">HDU 3861&period;The King&rsquo;s Problem 强联通分量&plus;最小路径覆盖</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwjz05z8.html">使用github&plus;jekyll搭建个人博客</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gexgm48.html">配置SQL Server on Linux（1）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kd4r09.html">10个最有用的 IntelliJ IDEA 插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1o67mq.html">合并查询结果集UNION（去重）&comma; UNION ALL（不去重），INTERSECT（交集），MINUS（差集，第一个结果集减去第二个结果集，第一个结果集中不在第二个结果集中的记录行），&lbrack;NOT&rsqb; EXIST</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpxre7q.html">PL&sol;SQL Developer使用技巧（部分）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1o0v2q.html">【二十六】php之文件编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gexxme8.html">Linux权限分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk44jd8.html">vue使用国际化</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mexvl0q.html">js文件加载优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j6n3x8.html">Fragment生命周期及实现点击导航图片切换fragment，Demo</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
